Index: codes/icosagcm/devel/src/output/xios_mod.F90
===================================================================
--- codes/icosagcm/devel/src/output/xios_mod.F90	(revision 879)
+++ codes/icosagcm/devel/src/output/xios_mod.F90	(revision 880)
@@ -1,67 +1,63 @@
 MODULE xios_mod
-
+  
 #ifdef CPP_USING_XIOS
-   USE xios
+  USE xios
 #endif
-   IMPLICIT NONE 
-
-  PUBLIC
-  LOGICAL,SAVE :: using_xios
-
-  INTEGER,SAVE :: ncell_i
-!$OMP THREADPRIVATE(ncell_i)
-  INTEGER,SAVE :: ncell_v
-!$OMP THREADPRIVATE(ncell_v)
-  INTEGER,SAVE :: ncell_e
-!$OMP THREADPRIVATE(ncell_e)
-
-  PRIVATE ncell_i,ncell_v,ncell_e
+
+  USE prec, ONLY : rstd
+  USE field_mod, ONLY : t_field, field_T, field_U, field_Z
+  USE domain_mod, ONLY : t_domain, t_cellset, domain, ndomain, mesh_loc
+  IMPLICIT NONE   
+  PRIVATE
+  SAVE
+
+  LOGICAL :: using_xios
+
+  INTEGER :: ncell_i, ncell_v, ncell_e
+!$OMP THREADPRIVATE(ncell_i, ncell_v, ncell_e)
+
+  PUBLIC :: using_xios, xios_init, &
+       xios_init_write_field,  xios_write_field_finalize, &
+       xios_write_field, xios_read_field
 
 #ifdef CPP_USING_XIOS
+
+  PUBLIC :: xios_timestep,    & 
+       xios_set_file_attr, xios_set_fieldgroup_attr, &
+       xios_set_filegroup_attr, xios_get_axis_attr, &
+       xios_send_field, xios_read_var, &
+       xios_update_calendar, xios_set_context
   
 CONTAINS
  
  SUBROUTINE xios_init
-   USE getin_mod
-   USE xios
-   USE mpipara
-   IMPLICIT NONE
-    TYPE(xios_context) :: ctx_hdl
-
-     using_xios=.TRUE.
-     CALL xios_context_initialize("icosagcm",comm_icosa)
-     CALL xios_get_handle("icosagcm",ctx_hdl)
-     CALL xios_set_current_context(ctx_hdl)
-   
- END SUBROUTINE xios_init  
- 
+   USE mpipara, ONLY : comm_icosa
+   TYPE(xios_context) :: ctx_hdl
+
+   using_xios=.TRUE.
+   CALL xios_context_initialize("icosagcm",comm_icosa)
+   CALL xios_get_handle("icosagcm",ctx_hdl)
+   CALL xios_set_current_context(ctx_hdl)   
+
+ END SUBROUTINE xios_init
+
  SUBROUTINE xios_init_write_field
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- USE time_mod
- USE metric, ONLY : vup,vdown, cell_glo
- USE disvert_mod, ONLY : presnivs
- IMPLICIT NONE
-  TYPE(xios_context) :: ctx_hdl
-  TYPE(xios_duration)      :: dtime
-  REAL(rstd) :: lev_value(llm)
-  REAL(rstd) :: lev_valuep1(llm+1)
-  REAL(rstd) :: nq_value(nqtot)
-  INTEGER :: ncell, ncell_tot, ncell_glo(0:mpi_size-1), displ
-  INTEGER :: ind, i,j,k,l,ij
-  REAL(rstd),ALLOCATABLE    :: lon(:), lat(:), bounds_lon(:,:), bounds_lat(:,:)
-  INTEGER, ALLOCATABLE      :: ind_glo(:)
-  TYPE(t_domain),POINTER :: d
-
-!$OMP BARRIER
-!$OMP MASTER
-!   CALL xios_context_initialize("icosagcm",comm_icosa)
+   USE time_mod, ONLY : dt, itau_out
+   USE grid_param, ONLY : llm, nqtot
+   USE mpi_mod, ONLY : MPI_INTEGER
+
+   TYPE(xios_context) :: ctx_hdl
+   TYPE(xios_duration)      :: dtime
+   REAL(rstd) :: lev_value(llm)
+   REAL(rstd) :: lev_valuep1(llm+1)
+   REAL(rstd) :: nq_value(nqtot)
+   INTEGER :: l, ncell, ncell_tot, displ
+   REAL(rstd),ALLOCATABLE    :: lon(:), lat(:), bounds_lon(:,:), bounds_lat(:,:)
+   INTEGER, ALLOCATABLE      :: ind_glo(:)
+   TYPE(t_domain),POINTER :: d
+   
+   !$OMP BARRIER
+   !$OMP MASTER
+   !   CALL xios_context_initialize("icosagcm",comm_icosa)
    CALL xios_get_handle("icosagcm",ctx_hdl)
    CALL xios_set_current_context(ctx_hdl)
@@ -71,262 +67,102 @@
    CALL xios_set_axis_attr("lev",n_glo=llm ,value=lev_value) ;
    CALL xios_set_axis_attr("levp1",n_glo=llm+1 ,value=lev_valuep1) ;
-   CALL xios_set_axis_attr("presnivs_mb",n_glo=llm, value=presnivs/100., unit="mb") ; 
    CALL xios_set_axis_attr("nq",n_glo=nqtot, value=nq_value) ;
    
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
-        
-     DO j=d%jj_begin,d%jj_end
-       DO i=d%ii_begin,d%ii_end
-         IF (domain(ind)%own(i,j)) ncell=ncell+1
-       ENDDO
-     ENDDO
-   ENDDO      
-   ncell_i=ncell
-   
-   CALL MPI_ALLGATHER(ncell,1,MPI_INTEGER,ncell_glo,1,MPI_INTEGER,comm_icosa,ierr)
-
-   displ=0
-   DO i=1,mpi_rank
-     displ=displ+ncell_glo(i-1)
-   ENDDO
-
-   ncell_tot=sum(ncell_glo(:))
-   
-   ALLOCATE(lon(ncell), lat(ncell), bounds_lon(0:5,ncell), bounds_lat(0:5,ncell), ind_glo(ncell)) 
-   
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
-        
-     DO j=d%jj_begin,d%jj_end
-       DO i=d%ii_begin,d%ii_end
-         IF (domain(ind)%own(i,j)) THEN 
-           ncell=ncell+1
-           CALL xyz2lonlat(d%xyz(:,i,j),lon(ncell),lat(ncell))
-           lon(ncell)=lon(ncell)*180/Pi
-           lat(ncell)=lat(ncell)*180/Pi
-           DO k=0,5
-             CALL xyz2lonlat(d%vertex(:,k,i,j),bounds_lon(k,ncell), bounds_lat(k,ncell))
-             bounds_lat(k,ncell)=bounds_lat(k,ncell)*180/Pi
-             bounds_lon(k,ncell)=bounds_lon(k,ncell)*180/Pi
-           ENDDO
-           ind_glo(ncell)=domain(ind)%assign_cell_glo(i,j)-1 
-         ENDIF
-       ENDDO
-     ENDDO
-   ENDDO         
-
+   !------------------ primal cells ------------------
+   CALL collect_bounds(6, mesh_loc%primal_own)
+   ncell_i=ncell   
    CALL xios_set_domaingroup_attr("i",ni_glo=ncell_tot, ibegin=displ, ni=ncell)
    CALL xios_set_domaingroup_attr("i", data_dim=1, type='unstructured' , nvertex=6, i_index=ind_glo)
    CALL xios_set_domaingroup_attr("i",lonvalue_1d=lon, latvalue_1d=lat, bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
-   
    DEALLOCATE(lon, lat, bounds_lon, bounds_lat,ind_glo) 
-    
-
-
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
-
-     DO j=d%jj_begin,d%jj_end
-       DO i=d%ii_begin,d%ii_end
-         DO k=0,5
-            IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                 .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               ncell=ncell+1
-            ENDIF
-         ENDDO
-       ENDDO
-     ENDDO
-   ENDDO
+   
+   !--------------------- dual cells ------------------
+   
+   CALL collect_bounds(3, mesh_loc%dual_own)
+   ncell_v=ncell
+   CALL xios_set_domain_attr("v",ni_glo=ncell_tot, ibegin=displ, ni=ncell)
+   CALL xios_set_domain_attr("v", data_dim=1, type='unstructured' , nvertex=3)
+   CALL xios_set_domain_attr("v",lonvalue_1d=lon, latvalue_1d=lat, bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
+   DEALLOCATE(lon, lat, bounds_lon, bounds_lat,ind_glo) 
+   
+   !---------------------- edges -----------------------
+   
+   CALL collect_bounds(2, mesh_loc%edge_own)
    ncell_e=ncell
-   
-   CALL MPI_ALLGATHER(ncell_e,1,MPI_INTEGER,ncell_glo,1,MPI_INTEGER,comm_icosa,ierr)
-   displ=0
-   DO i=1,mpi_rank
-     displ=displ+ncell_glo(i-1)
-   ENDDO
-   ncell_tot=sum(ncell_glo(:))
-   
-   ALLOCATE(lon(ncell), lat(ncell), bounds_lon(0:1,ncell), bounds_lat(0:1,ncell),ind_glo(ncell)) 
-
-
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
-     CALL swap_dimensions(ind)
-     CALL swap_geometry(ind)
-
-     DO j=d%jj_begin,d%jj_end
-       DO i=d%ii_begin,d%ii_end
-         DO k=0,5
-           IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                 .AND. d%edge_assign_pos(k,i,j)==k) THEN
-              ncell=ncell+1
-              ij=(j-1)*iim+i
-
-              lon(ncell)=lon_e(ij+u_pos(k+1))*180/Pi
-              lat(ncell)=lat_e(ij+u_pos(k+1))*180/Pi
-               
-              CALL xyz2lonlat(d%vertex(:,MOD((k-1)+6,6),i,j),bounds_lon(0,ncell), bounds_lat(0,ncell))
-              CALL xyz2lonlat(d%vertex(:,k,i,j),bounds_lon(1,ncell), bounds_lat(1,ncell))
-              bounds_lon(:,ncell)=bounds_lon(:,ncell)*180/Pi
-              bounds_lat(:,ncell)=bounds_lat(:,ncell)*180/Pi
-              ind_glo(ncell)=cell_glo(d%assign_cell_glo(i,j))%edge(MOD(k+d%delta(i,j)+6,6))-1 
-           ENDIF               
-         ENDDO
-       ENDDO
-     ENDDO
-   ENDDO
    CALL xios_set_domain_attr("u",ni_glo=ncell_tot, ibegin=displ, ni=ncell)
    CALL xios_set_domain_attr("u", data_dim=1, type='unstructured' , nvertex=2, i_index=ind_glo)
    CALL xios_set_domain_attr("u",lonvalue_1d=lon, latvalue_1d=lat, bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
-
    DEALLOCATE(lon, lat, bounds_lon, bounds_lat,ind_glo) 
-
-
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
-        
-     DO j=d%jj_begin+1,d%jj_end
-       DO i=d%ii_begin,d%ii_end-1
-         ncell=ncell+1
-       ENDDO
-     ENDDO
-
-     DO j=d%jj_begin,d%jj_end-1
-       DO i=d%ii_begin+1,d%ii_end
-          ncell=ncell+1
-        ENDDO
-     ENDDO
-
-   ENDDO      
-   
-   ncell_v=ncell
-   
-   CALL MPI_ALLGATHER(ncell,1,MPI_INTEGER,ncell_glo,1,MPI_INTEGER,comm_icosa,ierr)
-
-   displ=0
-   DO i=1,mpi_rank
-     displ=displ+ncell_glo(i-1)
-   ENDDO
-
-   ncell_tot=sum(ncell_glo(:))
-   
-   ALLOCATE(lon(ncell), lat(ncell), bounds_lon(0:2,ncell), bounds_lat(0:2,ncell)) 
-   
-   ncell=0
-   DO ind=1,ndomain
-     d=>domain(ind)
- 
-     DO j=d%jj_begin+1,d%jj_end
-       DO i=d%ii_begin,d%ii_end-1
-           ncell=ncell+1
-           CALL xyz2lonlat(d%vertex(:,vdown,i,j),lon(ncell),lat(ncell))
-           lon(ncell)=lon(ncell)*180/Pi
-           lat(ncell)=lat(ncell)*180/Pi
-
-           CALL xyz2lonlat(d%xyz(:,i,j),bounds_lon(0,ncell), bounds_lat(0,ncell))
-           CALL xyz2lonlat(d%xyz(:,i,j-1),bounds_lon(1,ncell), bounds_lat(1,ncell))
-           CALL xyz2lonlat(d%xyz(:,i+1,j-1),bounds_lon(2,ncell), bounds_lat(2,ncell))
-
-           DO k=0,2
-             bounds_lat(k,ncell)=bounds_lat(k,ncell)*180/Pi
-             bounds_lon(k,ncell)=bounds_lon(k,ncell)*180/Pi
-           ENDDO
-         ENDDO
-       ENDDO 
- 
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           ncell=ncell+1
-           CALL xyz2lonlat(d%vertex(:,vup,i,j),lon(ncell),lat(ncell))
-           lon(ncell)=lon(ncell)*180/Pi
-           lat(ncell)=lat(ncell)*180/Pi
-           CALL xyz2lonlat(d%xyz(:,i,j),bounds_lon(0,ncell), bounds_lat(0,ncell))
-           CALL xyz2lonlat(d%xyz(:,i,j+1),bounds_lon(1,ncell), bounds_lat(1,ncell))
-           CALL xyz2lonlat(d%xyz(:,i-1,j+1),bounds_lon(2,ncell), bounds_lat(2,ncell))
-
-           DO k=0,2
-             bounds_lat(k,ncell)=bounds_lat(k,ncell)*180/Pi
-             bounds_lon(k,ncell)=bounds_lon(k,ncell)*180/Pi
-           ENDDO
-         ENDDO
-       ENDDO 
-        
-   ENDDO         
-
-  
-   CALL xios_set_domain_attr("v",ni_glo=ncell_tot, ibegin=displ, ni=ncell)
-   CALL xios_set_domain_attr("v", data_dim=1, type='unstructured' , nvertex=3)
-   CALL xios_set_domain_attr("v",lonvalue_1d=lon, latvalue_1d=lat, bounds_lon_1d=bounds_lon, bounds_lat_1d=bounds_lat)
-
-
+   
    dtime%second=dt
    CALL xios_set_timestep(dtime)
    
    CALL xios_set_fieldgroup_attr("standard_output", freq_op=itau_out*xios_timestep, freq_offset=(itau_out-1)*xios_timestep)
-    
+   
    CALL xios_close_context_definition()
-!$OMP END MASTER
-!$OMP BARRIER
+   !$OMP END MASTER
+   !$OMP BARRIER
+   
+ CONTAINS
+   
+   SUBROUTINE collect_bounds(nvert, cells)
+     USE mpipara, ONLY : comm_icosa, mpi_size, mpi_rank
+     INTEGER, INTENT(IN) :: nvert
+     TYPE(t_cellset)     :: cells(:)
+     INTEGER :: i, ind, n_beg, n_end, ierr, ncell_glo(0:mpi_size-1)
+     ncell = SUM(cells%ncell)
+     CALL MPI_ALLGATHER(ncell,1,MPI_INTEGER, &
+          ncell_glo,1, MPI_INTEGER, comm_icosa, ierr)
+     displ=0
+     DO i=1,mpi_rank
+        displ=displ+ncell_glo(i-1)
+     ENDDO
+     ncell_tot=sum(ncell_glo(:))
+     
+     ALLOCATE(lon(ncell), lat(ncell), ind_glo(ncell))
+     ALLOCATE(bounds_lon(nvert,ncell), bounds_lat(nvert,ncell))
+     
+     n_beg=0
+     DO ind=1,ndomain
+        n_end = n_beg + cells(ind)%ncell
+        ind_glo(n_beg+1:n_end) = cells(ind)%ind_glo(:)
+        lon(n_beg+1:n_end) = cells(ind)%lon(:)
+        lat(n_beg+1:n_end) = cells(ind)%lat(:)
+        bounds_lon(:,n_beg+1:n_end) = cells(ind)%bnds_lon(:,:)
+        bounds_lat(:,n_beg+1:n_end) = cells(ind)%bnds_lat(:,:)
+        n_beg = n_end
+     END DO
+   END SUBROUTINE collect_bounds
    
  END SUBROUTINE xios_init_write_field
-  
-  
+ 
  SUBROUTINE xios_write_field(name,field)
- USE field_mod
- IMPLICIT NONE 
    CHARACTER(LEN=*),INTENT(IN) :: name
    TYPE(t_field), POINTER :: field(:)
-   CHARACTER(LEN=10) :: str_number
-   INTEGER :: iq
+   TYPE(t_cellset), POINTER :: cells(:)
+   INTEGER :: ncells
 
 !$OMP BARRIER
 !$OMP MASTER
-   
-   IF (Field(1)%field_type==field_T) THEN
-     IF (field(1)%ndim==2) THEN
-        CALL xios_write_field_scalar(name,field,1,1)
-     ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_write_field_scalar(name,field,size(field(1)%rval3d,2),1)
-     ELSE IF (field(1)%ndim==4) THEN
-!        DO iq=1,size(field(1)%rval4d,3)
-!          WRITE(str_number,'(i10)') iq
-!          CALL xios_write_field_scalar(name//TRIM(ADJUSTL(str_number)),field,size(field(1)%rval4d,2),iq)
-          CALL xios_write_field_scalar(name,field,size(field(1)%rval4d,2),size(field(1)%rval4d,3))
-!        ENDDO
-     ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-     ENDIF
-
-   ELSE IF (Field(1)%field_type==field_U) THEN
-      IF (field(1)%ndim==2) THEN
-        CALL xios_write_field_U(name,field,1,1)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_write_field_U(name,field,size(field(1)%rval3d,2),1)
-      ELSE IF (field(1)%ndim==4) THEN
-        CALL xios_write_field_U(name,field,size(field(1)%rval4d,2),size(field(1)%rval4d,3))
-      ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-      ENDIF
-
-    ELSE IF (Field(1)%field_type==field_Z) THEN
-     IF (field(1)%ndim==2) THEN
-        CALL xios_write_field_vort(name,field,1)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_write_field_vort(name,field,size(field(1)%rval3d,2))
-      ELSE IF (field(1)%ndim==4) THEN
-        DO iq=1,size(field(1)%rval4d,3)
-          WRITE(str_number,'(i10)') iq
-          CALL xios_write_field_vort(name//TRIM(ADJUSTL(str_number)),field,size(field(1)%rval4d,2),iq)
-        ENDDO
-      ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-      ENDIF
-    ENDIF
+
+   SELECT CASE(field(1)%field_type)
+   CASE(field_T)
+      cells => mesh_loc%primal_own
+      ncells = ncell_i
+   CASE(field_U)
+      cells => mesh_loc%edge_own
+      ncells = ncell_e
+   CASE(field_Z)
+      cells => mesh_loc%dual_own
+      ncells = ncell_v
+   END SELECT
+
+   IF (field(1)%ndim>4) THEN
+      PRINT *, "xios_write_field : dimension > 4 are not supported for now"
+   ELSE
+      CALL xios_write_field_hex(name, field, cells, & 
+           ncells, field(1)%dim3, field(1)%dim4)
+   END IF
+   
 !$OMP END MASTER
 !$OMP BARRIER
@@ -335,52 +171,31 @@
 
  SUBROUTINE xios_read_field(name,field)
- USE field_mod
- IMPLICIT NONE 
    CHARACTER(LEN=*),INTENT(IN) :: name
    TYPE(t_field), POINTER :: field(:)
-   CHARACTER(LEN=10) :: str_number
-   INTEGER :: iq
+   TYPE(t_cellset), POINTER :: cells(:)
+   INTEGER :: ncells
 
 !$OMP BARRIER
 !$OMP MASTER
-   
-   IF (Field(1)%field_type==field_T) THEN
-     IF (field(1)%ndim==2) THEN
-        CALL xios_read_field_scalar(name,field,1,1)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_read_field_scalar(name,field,size(field(1)%rval3d,2),1)
-      ELSE IF (field(1)%ndim==4) THEN
-!        DO iq=1,size(field(1)%rval4d,3)
-!          WRITE(str_number,'(i10)') iq
-!          CALL xios_read_field_scalar(name//TRIM(ADJUSTL(str_number)),field,size(field(1)%rval4d,2),iq)
-!        ENDDO
-          CALL xios_read_field_scalar(name,field,size(field(1)%rval4d,2),size(field(1)%rval4d,3))
-      ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-      ENDIF
-   ELSE IF (Field(1)%field_type==field_U) THEN
-     IF (field(1)%ndim==2) THEN
-        CALL xios_read_field_u(name,field,1,1)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_read_field_u(name,field,size(field(1)%rval3d,2),1)
-      ELSE IF (field(1)%ndim==4) THEN
-          CALL xios_read_field_u(name,field,size(field(1)%rval4d,2),size(field(1)%rval4d,3))
-      ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-      ENDIF
-    ELSE IF (Field(1)%field_type==field_Z) THEN
-     IF (field(1)%ndim==2) THEN
-        CALL xios_read_field_vort(name,field,1)
-      ELSE IF (field(1)%ndim==3) THEN
-        CALL xios_read_field_vort(name,field,size(field(1)%rval3d,2))
-      ELSE IF (field(1)%ndim==4) THEN
-        DO iq=1,size(field(1)%rval4d,3)
-          WRITE(str_number,'(i10)') iq
-          CALL xios_read_field_vort(name//TRIM(ADJUSTL(str_number)),field,size(field(1)%rval4d,2),iq)
-        ENDDO
-      ELSE
-        PRINT *, "xios_write_field : dimension > 4 are not supported for now"
-      ENDIF
-    ENDIF
+
+   SELECT CASE(field(1)%field_type)
+   CASE(field_T)
+      cells => mesh_loc%primal_own
+      ncells = ncell_i
+   CASE(field_U)
+      cells => mesh_loc%edge_own
+      ncells = ncell_e
+   CASE(field_Z)
+      cells => mesh_loc%dual_own
+      ncells = ncell_v
+   END SELECT
+
+   IF (field(1)%ndim>4) THEN
+      PRINT *, "xios_read_field : dimension > 4 are not supported for now"
+   ELSE
+      CALL xios_read_field_hex(name, field, cells, & 
+           ncells, field(1)%dim3, field(1)%dim4)
+   END IF
+   
 !$OMP END MASTER
 !$OMP BARRIER
@@ -388,78 +203,80 @@
  END SUBROUTINE xios_read_field
 
-
- 
- SUBROUTINE xios_write_field_scalar(name,field,nlev,nq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN) :: nq
-   
-   REAL(rstd) :: field_tmp(ncell_i,nlev,nq)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,ij,ind
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field_tmp(n,1,1)=field(ind)%rval2d(ij)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO
-   ELSE IF (field(1)%ndim==3) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field_tmp(n,:,1)=field(ind)%rval3d(ij,:)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO
-   ELSE IF (field(1)%ndim==4) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field_tmp(n,:,:)=field(ind)%rval4d(ij,:,:)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO     
-   ENDIF
-   
-   CALL xios_send_field(name,field_tmp)
- 
- END SUBROUTINE xios_write_field_scalar  
-
+ SUBROUTINE xios_write_field_hex(name, field, cells, ncell_tot, nlev, nq)
+   CHARACTER(LEN=*),INTENT(IN) :: name
+   TYPE(t_field) :: field(:)
+   TYPE(t_cellset), TARGET :: cells(:)
+   INTEGER,INTENT(IN) :: ncell_tot, nlev, nq
+
+   REAL(rstd) :: field_tmp(ncell_tot,nlev,nq)
+   TYPE(t_cellset), POINTER :: cellset
+   INTEGER :: ind, n_beg, n_end, n, ij, sgn
+   LOGICAL :: signed
+
+   IF(ALLOCATED(cells(1)%sgn)) THEN
+      signed=.TRUE.
+   ELSE
+      signed=.FALSE.
+      sgn=1
+   END IF
+
+   n_beg=0
+   DO ind=1,ndomain
+      cellset => cells(ind)
+      n_end = n_beg + cellset%ncell
+      DO n=1, cellset%ncell
+         ij = cellset%ij(n)
+         IF(signed) sgn = cellset%sgn(n)
+         SELECT CASE(field(1)%ndim)
+         CASE(2)
+            field_tmp(n_beg+n,1,1) = sgn*field(ind)%rval2d(ij)
+         CASE(3)
+            field_tmp(n_beg+n,:,1) = sgn*field(ind)%rval3d(ij,:)
+         CASE(4)
+            field_tmp(n_beg+n,:,:) = sgn*field(ind)%rval4d(ij,:,:)
+         END SELECT
+      END DO
+   END DO
+   CALL xios_send_field(name,field_tmp)  
+ END SUBROUTINE xios_write_field_hex
+
+SUBROUTINE xios_read_field_hex(name, field, cells, ncell_tot, nlev, nq)
+   CHARACTER(LEN=*),INTENT(IN) :: name
+   TYPE(t_field) :: field(:)
+   TYPE(t_cellset), TARGET :: cells(:)
+   INTEGER,INTENT(IN) :: ncell_tot, nlev, nq
+
+   REAL(rstd) :: field_tmp(ncell_tot,nlev,nq)
+   TYPE(t_cellset), POINTER :: cellset
+   INTEGER :: ind, n_beg, n_end, n, ij, sgn
+   LOGICAL :: signed
+
+   CALL xios_recv_field(name,field_tmp)
+
+   IF(ALLOCATED(cells(1)%sgn)) THEN
+      signed=.TRUE.
+   ELSE
+      signed=.FALSE.
+      sgn=1
+   END IF
+
+   n_beg=0
+   DO ind=1,ndomain
+      cellset => cells(ind)
+      n_end = n_beg + cellset%ncell
+      DO n=1, cellset%ncell
+         ij = cellset%ij(n)
+         IF(signed) sgn = cellset%sgn(n)
+         SELECT CASE(field(1)%ndim)
+         CASE(2)
+            field(ind)%rval2d(ij) = sgn*field_tmp(n_beg+n,1,1) 
+         CASE(3)
+            field(ind)%rval3d(ij,:) = sgn*field_tmp(n_beg+n,:,1)
+         CASE(4)
+            field(ind)%rval4d(ij,:,:) = sgn*field_tmp(n_beg+n,:,:)
+         END SELECT
+      END DO
+   END DO
+ END SUBROUTINE xios_read_field_hex
 
  SUBROUTINE xios_read_var(name,field)
